#include <stdio.h>

int val[] = {1,5,10,50};

int test (int p, int c1, int c2, int c3, int c4, int *out) {
	int counts[4];
	int i;
	int rest = p;

	for (i = 0; i < 4; i++) {
		out [i] = 0;
	}
	
	counts[0] = c1;
	counts[1] = counts[0] + 5 * c2;
	counts[2] = counts[1] + 10 * c3;
	counts[3] = counts[2] + 50 * c4;

	for (i = 0; i < 4; i++) {
		if (p <= counts[i])
			break;
	}

	if (i >= 4) {
		return -10;
	}

	
	for (; i > 0; i--) {
		int delta = rest - counts[i - 1];
		if (delta > 0) {
			int xcnt = (delta - 1) / val[i] + 1;
			delta = xcnt * val[i];
			if (delta > rest) {
				return -10;
			}
			out[i] = xcnt;
			rest -= delta;
		}
	}

	out[0] = rest;

	if (out[0] > c1 || out[1] > c2 || out[2] > c3 || out[3] > c4) 
		return -10;
	

	out[3] *= 2;
	return out[0] + out[1] + out [2] + out[3];
}


int main() {
int p, c1,c2,c3,c4;
	int t1;
	int t2;
	int res1[5], res2[5];
	int *res;

	while (1) {
		scanf ("%d%d%d%d%d",&p,&c1,&c2,&c3,&c4);
		if (!p)
			break;

		t1 = test(p,c1,c2,c3,c4 / 2,res1);
		t2 = -5;
		if (c4 > 0 && p >= 25) {
			t2 = test(p - 25,c1,c2,c3, (c4 - 1) / 2,res2);
			if (t2 >= 0)  {
				t2++;
				res2[3] ++;
			}
		}

		if (t2 > 0 && t2 > t1) {
			res = res2;
		} else if (t1 > 0) {
			res = res1;
		} else {
			res = NULL;
		}

		if (!res) {
			printf("Charlie cannot buy coffee.\n");
		} else {
			printf("Throw in %d cents, %d nickels, %d dimes, and %d quarters.\n", res[0],res[1],res[2],res[3]);
		}
	}
	return 0;
}
